//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "unit1.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	m_inet1 = "localhost";
    m_inet2 = "1024";
    m_inet3 = "1024";
    m_ipx1  = "00000000";
    m_ipx2  = "ffffffffffff";
    m_ipx3  = "2fff";
    m_ipx4  = "2fff";
    m_netbs1 = "GAME1";
    m_nbLana = -2;
    ZeroMemory(m_mas,sizeof(m_mas));
    ch1 = 'X';
    ch2 = '0';
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BExitClick(TObject *Sender)
{
	closesocket(sock);
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
	CBProtocol->ItemIndex = 0;
	CBProtocolChange(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CBProtocolChange(TObject *Sender)
{
    m_hod = false;
    m_first = false;
    m_first_recv = false;
	StatusBar1->Panels->Items[0]->Text = "";
   	WSAAsyncSelect(sock, Handle, 0, 0);
    closesocket(sock);
	WSACleanup();
	WSADATA WSAData;
    WSAStartup(0x0101, &WSAData);
   	switch(CBProtocol->ItemIndex)
    {
     	case 0: //TCP
                m_af = AF_INET;
                m_type = SOCK_STREAM;
                m_protocol = IPPROTO_TCP;
                EAddr->MaxLength = 0;
                EPort->MaxLength = 0;
        		RadioGroup1->Enabled = true;
                EPort->Enabled = true;
                EPort2->Enabled = false;
                Label5->Enabled = false;
                ESock->Visible = false;
                Label6->Visible = false;
                BListen->Caption = " ";
                Label1->Caption = "";
                Label2->Caption = "";
                Label5->Caption = "";
                EAddr->Text = m_inet1;
                EPort->Text = m_inet2;
                EPort2->Text = "";
				RadioGroup1Click(NULL);
                break;
        case 1: //UDP
                m_af = AF_INET;
                m_type = SOCK_DGRAM;
                m_protocol = IPPROTO_UDP;
                EAddr->MaxLength = 0;
                EPort->MaxLength = 0;
        		RadioGroup1->Enabled = false;
                EAddr->Enabled = true;
                Label1->Enabled = true;
				EPort->Enabled = true;
                Label2->Enabled = true;
                EPort2->Enabled = true;
                Label5->Enabled = true;
                BListen->Enabled = true;
                BConnect->Enabled = false;
                BDisconnect->Enabled = false;
                ESock->Visible = false;
                Label6->Visible = false;
                BListen->Caption = " ";
                Label1->Caption = "";
                Label2->Caption = "";
                Label5->Caption = "()";
                EAddr->Text = m_inet1;
                EPort->Text = m_inet2;
                EPort2->Text = m_inet3;
                break;
        case 2: //SPX
                m_af = AF_IPX;
                m_type = SOCK_STREAM;//SOCK_SEQPACKET;
                m_protocol = NSPROTO_SPX;
                EAddr->MaxLength = 8;
                EPort->MaxLength = 12;
        		RadioGroup1->Enabled = true;
                EPort->Enabled = true;
                EPort2->Enabled = true;
                Label5->Enabled = true;
                ESock->Visible = false;
                Label6->Visible = false;
                BListen->Caption = " ";
                Label1->Caption = "";
                Label2->Caption = "";
                Label5->Caption = "";
                EAddr->Text = m_ipx1;
                EPort->Text = m_ipx2;
                EPort2->Text = m_ipx3;
				RadioGroup1Click(NULL);
        		break;
        case 3: //IPX
                m_af = AF_IPX;
                m_type = SOCK_DGRAM;
                m_protocol = NSPROTO_IPX;
                EAddr->MaxLength = 8;
                EPort->MaxLength = 12;
        		RadioGroup1->Enabled = false;
                EAddr->Enabled = true;
                Label1->Enabled = true;
				EPort->Enabled = true;
                Label2->Enabled = true;
                EPort2->Enabled = true;
                Label5->Enabled = true;
                BConnect->Enabled = false;
                BDisconnect->Enabled = false;
                BListen->Enabled = true;
                ESock->Visible = true;
                Label6->Visible = true;
                BListen->Caption = " ";
                Label1->Caption = "";
                Label2->Caption = "";
                Label5->Caption = "";
                EAddr->Text = m_ipx1;
                EPort->Text = m_ipx2;
                EPort2->Text = m_ipx3;
                ESock->Text = m_ipx4;
        		break;
        case 4: //SPX
                m_af = AF_IPX;
                m_type = SOCK_STREAM;//SOCK_SEQPACKET;
                m_protocol = NSPROTO_SPXII;
                EAddr->MaxLength = 8;
                EPort->MaxLength = 12;
        		RadioGroup1->Enabled = true;
                EPort->Enabled = true;
                EPort2->Enabled = true;
                Label5->Enabled = true;
                ESock->Visible = false;
                Label6->Visible = false;
                BListen->Caption = " ";
                Label1->Caption = "";
                Label2->Caption = "";
                Label5->Caption = "";
                EAddr->Text = m_ipx1;
                EPort->Text = m_ipx2;
                EPort2->Text = m_ipx3;
				RadioGroup1Click(NULL);
        		break;
        case 5: //NetBIOS  
                m_af = AF_NETBIOS;
                m_type = SOCK_SEQPACKET;
                m_protocol = m_nbLana;
                EAddr->MaxLength = 0;
                EPort->MaxLength = 0;
        		RadioGroup1->Enabled = true;
                EAddr->Enabled = true;
                Label1->Enabled = true;
                EPort->Enabled = true;
                EPort2->Enabled = true;
                Label5->Enabled = false;
                ESock->Visible = false;
                Label6->Visible = false;
                BListen->Caption = " ";
                Label1->Caption = "";
                Label2->Caption = "";
                Label5->Caption = "";
                EAddr->Text = m_netbs1;
                EPort->Text = IntToStr(m_nbLana);
                EPort2->Text = "";
        		break;
    }
}
//---------------------------------------------------------------------------
AnsiString TForm1::m_comp(AnsiString str1, AnsiString str2)
{
	int i,j;
    AnsiString result = AnsiString::StringOfChar('-',4);
	for(i=1; i<5; i++)
    {
		if(str1[i] == str2[i]) result[i] = '';
        else
        {
        	for(j=1; j<5; j++) if(str1[i] == str2[j]) break;
            if(j<5) result[i] = 'K';
        }
    }
    return result;
}
//---------------------------------------------------------------------------
bool TForm1::m_Send(char src[2])
{
	if(m_hod)
    {
        if(!m_first_recv) m_first = true;
    	switch(CBProtocol->ItemIndex)
	    {
    	    case 0: //TCP
	        case 2: //SPX
            case 4: //SPXII
            case 5: //NetBIOS
        	{
	        	if(send(sock, src, 2, 0) == SOCKET_ERROR) return false;
    	    }
        	break;
	        case 1: //UDP
    	    {
        		SOCKADDR_IN dest_sin;
            	if(!FillAddrIN(&dest_sin, TRUE))
	            {
    	        	closesocket(sock);
        	        return false;
	            }
            	if(sendto(sock, src, 2, 0, (PSOCKADDR)&dest_sin, sizeof(dest_sin)) == SOCKET_ERROR)	return false;
        	}
    	    break;
        	case 3: //IPX
	        {
    	    	SOCKADDR_IPX dest_sipx;
				if(!FillAddrIPX(&dest_sipx, TRUE))
				{
	            	closesocket(sock);
    	            return false;
        	    }
            	if(sendto(sock, src, 2, 0, (PSOCKADDR)&dest_sipx, sizeof(dest_sipx)) == SOCKET_ERROR) return false;
	        }
    	    break;
	    }
        return true;
	}
    return false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BConnectClick(TObject *Sender)
{
    if(m_af == AF_NETBIOS)
    {
        m_nbLana = StrToInt(EPort->Text);
        m_protocol = m_nbLana;
    }
	closesocket(sock);
	sock = socket(m_af, m_type, m_protocol);
    if(sock == INVALID_SOCKET)
    {
    	Application->MessageBox("socket() failed", "Error", MB_OK);
        return;
    }
    switch(m_af)
    {
     	case AF_INET:
    	{
			SOCKADDR_IN dest_sin;
	    	if(!FillAddrIN(&dest_sin, TRUE))
		    {
    			closesocket(sock);
        		return;
		    }
    		if(connect(sock, (PSOCKADDR)&dest_sin, sizeof(dest_sin)) < 0)
	    	{
    			closesocket(sock);
	        	Application->MessageBox("connect() failed", "Error", MB_OK);
		        return;
    		}
        }
        break;
        case AF_IPX:
        {
			SOCKADDR_IPX dest_sipx;
			if(!FillAddrIPX(&dest_sipx, TRUE))
			{
            	closesocket(sock);
                break;
            }
    		if(connect(sock, (PSOCKADDR)&dest_sipx, sizeof(dest_sipx)) < 0)
	    	{
    			closesocket(sock);
	        	Application->MessageBox("connect() failed", "Error", MB_OK);
		        return;
    		}
        }
        break;
        case AF_NETBIOS:
        {
        	SOCKADDR_NB dest_snb;
            SET_NETBIOS_SOCKADDR(&dest_snb, NETBIOS_GROUP_NAME, EAddr->Text.c_str(), 0);
    		if(connect(sock, (PSOCKADDR)&dest_snb, sizeof(dest_snb)) < 0)
	    	{
    			closesocket(sock);
	        	Application->MessageBox("connect() failed", "Error", MB_OK);
		        return;
    		}
        }
        break;
    }
    StatusBar1->Panels->Items[0]->Text = " ";
    if(WSAAsyncSelect(sock, Handle, WSA_NETEVENT, FD_READ|FD_CLOSE) > 0)
    {
    	wsprintf(szBuff, "%d (0x%x)");
        Application->MessageBox("Error on WSAAsyncSelect()", szBuff, MB_OK);
        closesocket( sock );
    }
	Button1Click(NULL);
    StatusBar1->Panels->Items[0]->Text = StatusBar1->Panels->Items[0]->Text + ".  .";
    m_hod = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BDisconnectClick(TObject *Sender)
{
    CBProtocolChange(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BListenClick(TObject *Sender)
{
    if(m_af == AF_NETBIOS)
    {
        m_nbLana = StrToInt(EPort->Text);
        m_protocol = m_nbLana;
    }
	switch(m_type)
    {
    	case SOCK_STREAM:
        case SOCK_SEQPACKET:
        {
        	closesocket(sock);
			sock = socket(m_af, m_type, m_protocol);
		    if(sock == INVALID_SOCKET)
		    {
            	sprintf(szBuff, "%d is the error", WSAGetLastError());
                Application->MessageBox(szBuff, "socket() failed", MB_OK);
		        return;
		    }
			switch(m_af)
		    {
		    	case AF_INET:
		        {
					SOCKADDR_IN local_sin;
				    if(!FillAddrIN(&local_sin, FALSE))
				    {
				        closesocket(sock);
        				return;
				    }
				    StatusBar1->Panels->Items[0]->Text = " .. (Async)";
				    if(bind(sock, (struct sockaddr FAR *) &local_sin, sizeof(local_sin)) == SOCKET_ERROR)
				    {
				        sprintf(szBuff, "%d is the error", WSAGetLastError());
        				Application->MessageBox(szBuff, "bind(sock) failed", MB_OK);
		        		closesocket(sock);
		        		return;
				    }
		        }
        		break;
		        case AF_IPX:
		        {
					SOCKADDR_IPX local_sipx;
                    if(!FillAddrIPX(&local_sipx, FALSE))
                    {
                    	closesocket(sock);
                        return;
                    }
				    StatusBar1->Panels->Items[0]->Text = " .. (Async)";
				    if(bind(sock, (struct sockaddr FAR *) &local_sipx, sizeof(local_sipx)) == SOCKET_ERROR)
				    {
				        sprintf(szBuff, "%d is the error", WSAGetLastError());
        				Application->MessageBox(szBuff, "bind(sock) failed", MB_OK);
		        		closesocket(sock);
		        		return;
				    }
                    char outtext[128];
                    SOCKADDR_IPX addr;
                    int addrlen = sizeof(addr);
				    if(getsockname(sock,(PSOCKADDR)&addr,&addrlen) == SOCKET_ERROR)
				    {
				        ShowMessage("ERROR getsocketname()");
				    }
				    else
				    {
				        lstrcpy(outtext, "   ");
				        GetAddrString(&addr, outtext + lstrlen(outtext));
				    }
                    StatusBar1->Panels->Items[0]->Text = AnsiString(outtext);
        		}
		        break;
                case AF_NETBIOS:
                {
                	SOCKADDR_NB local_snb;
           			SET_NETBIOS_SOCKADDR(&local_snb, NETBIOS_GROUP_NAME, EAddr->Text.c_str(), 0);
					if(bind(sock, (struct sockaddr FAR *) &local_snb, sizeof(local_snb)) == SOCKET_ERROR)
				    {
				        sprintf(szBuff, "%d is the error", WSAGetLastError());
        				Application->MessageBox(szBuff, "bind(sock) failed", MB_OK);
		        		closesocket(sock);
		        		return;
				    }
                    StatusBar1->Panels->Items[0]->Text = "  ...";
                }
                break;
		    }
		    if(listen(sock, MAX_PENDING_CONNECTS) < 0)
		    {
        		sprintf(szBuff, "%d is the error", WSAGetLastError());
		        Application->MessageBox(szBuff, "listen(sock) failed", MB_OK);
		        return;
		    }
		    if(WSAAsyncSelect(sock, Handle, WSA_ACCEPT, FD_ACCEPT) > 0)
		    {
        		wsprintf( szBuff, "%d (0x%x)");
		        Application->MessageBox("Error on WSAAsyncSelect()", szBuff, MB_OK);
		        StatusBar1->Panels->Items[0]->Text = "Async listen cancelled";
		        closesocket( sock );
		    }
        }
        break;
     	case SOCK_DGRAM:
        {
			switch(m_af)
            {
             	case AF_INET:
                {
					m_inet1 = EAddr->Text;
                    m_inet2 = EPort->Text;
                    m_inet3 = EPort2->Text;
                }
                break;
                case AF_IPX:
                {
					m_ipx1 = EAddr->Text;
                    m_ipx2 = EPort->Text;
                    m_ipx3 = EPort2->Text;
                    m_ipx4 = ESock->Text;
                }
                break;
            }
			CBProtocolChange(NULL);
            closesocket(sock);
            sock = socket(m_af, m_type, m_protocol);
            if(sock == INVALID_SOCKET)
            {
            	Application->MessageBox("socket() failed", "Error", MB_OK);
                break;
            }
            switch(m_af)
            {
            	case AF_INET:
                {
		        	SOCKADDR_IN local_sin;
        		    local_sin.sin_family = AF_INET;
		            local_sin.sin_addr.s_addr = INADDR_ANY;
		            local_sin.sin_port = htons((u_short)StrToInt(EPort2->Text));
        		    if (bind(sock, (struct sockaddr FAR *)&local_sin, sizeof(local_sin)) == SOCKET_ERROR)
		            {
        		    	sprintf(szBuff, "%d is the error", WSAGetLastError());
                		Application->MessageBox(szBuff, "bind(sock) failed", MB_OK);
		                closesocket(sock);
        		        break;
                    }
                    StatusBar1->Panels->Items[0]->Text = " ";
                }
                break;
                case AF_IPX:
                {
                	SOCKADDR_IPX local_sipx;
                    ZeroMemory(&local_sipx, sizeof(local_sipx));
                    local_sipx.sa_family = AF_IPX;
                    AtoH(ESock->Text.c_str(), (char *)&local_sipx.sa_socket, 2); 		// Network order
	      		    if (bind(sock, (struct sockaddr FAR *)&local_sipx, sizeof(local_sipx)) == SOCKET_ERROR)
		            {
        		    	sprintf(szBuff, "%d is the error", WSAGetLastError());
                		Application->MessageBox(szBuff, "bind(sock) failed", MB_OK);
		                closesocket(sock);
        		        break;
                    }
                    char outtext[128];
                    SOCKADDR_IPX addr;
                    int addrlen = sizeof(addr);
				    if(getsockname(sock,(PSOCKADDR)&addr,&addrlen) == SOCKET_ERROR)
				    {
				        ShowMessage("ERROR getsocketname()");
				    }
				    else
				    {
				        lstrcpy(outtext, "   ");
				        GetAddrString(&addr, outtext + lstrlen(outtext));
				    }
                    StatusBar1->Panels->Items[0]->Text = AnsiString(outtext);
                }
                break;
            }
            WSAAsyncSelect(sock, Handle, WSA_NETEVENT, FD_READ);
			Button1Click(NULL);
		    StatusBar1->Panels->Items[0]->Text = StatusBar1->Panels->Items[0]->Text + ".  .";
            m_hod = true;
        }
        break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioGroup1Click(TObject *Sender)
{
	switch(RadioGroup1->ItemIndex == 0)
    {
     	case 0:
        		BListen->Enabled = false;
				BConnect->Enabled = true;
                BDisconnect->Enabled = true;
                EAddr->Enabled = true;
                Label1->Enabled = true;
                if(m_protocol == NSPROTO_SPX)
                {
                 	EPort->Enabled = true;
                    Label2->Enabled = true;
                }
                break;
        case 1:
        		BListen->Enabled = true;
				BConnect->Enabled = false;
                BDisconnect->Enabled = false;
                EAddr->Enabled = false;
                Label1->Enabled = false;
                if(m_protocol == NSPROTO_SPX)
                {
                 	EPort->Enabled = false;
                    Label2->Enabled = false;
                }
                break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	int status;
	WSADATA WSAData;
    char szTemp[80];
    if ((status = WSAStartup(0x0101, &WSAData)) == 0)
    {
    	Caption = AnsiString(WSAData.szDescription) + " " + AnsiString(WSAData.szSystemStatus);
    }
    else
    {
    	sprintf(szTemp, "%d is the err", status);
        Application->MessageBox(szTemp, "Error", MB_OK);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
	WSACleanup();
}
//---------------------------------------------------------------------------
bool TForm1::FillAddrIN(PSOCKADDR_IN psin, bool bClient)
{
   	DWORD dwSize;
	PHOSTENT phe;
   	char szTemp[200];
    ZeroMemory(psin, sizeof(SOCKADDR_IN));
   	psin->sin_family = AF_INET;
   	if (bClient)
   	{
    	if(isalpha(EAddr->Text[1]))
        {
	      	phe = gethostbyname(EAddr->Text.c_str());
    	  	if (phe == NULL)
        	{
         		sprintf(szTemp, "%d is the error. Make sure '%s' is listed in the hosts file.", WSAGetLastError(), szBuff);
	        	Application->MessageBox(szTemp, "gethostbyname() failed.", MB_OK);
    	    	return FALSE;
      		}
	      	memcpy((char FAR *)&(psin->sin_addr), phe->h_addr, phe->h_length);
        }
        else
        {
        	psin->sin_addr.s_addr = inet_addr(EAddr->Text.c_str());
        }
   	}
    else
    { // server
      	dwSize = sizeof(szBuff);
      	gethostname(szBuff, dwSize);
      	psin->sin_addr.s_addr = INADDR_ANY;
    }
    psin->sin_port = htons((u_short)StrToInt(EPort->Text));
   	return true;
}
//---------------------------------------------------------------------------
bool TForm1::FillAddrIPX(PSOCKADDR_IPX psipx, bool bClient)
{
    ZeroMemory(psipx, sizeof(SOCKADDR_IPX));
	psipx->sa_family = AF_IPX;
    if(bClient)
    {
    	AtoH(EAddr->Text.c_str(), (char *)&psipx->sa_netnum, 4);        // Network order
        AtoH(EPort->Text.c_str(), (char *)&psipx->sa_nodenum, 6);  		// Network order
        AtoH(EPort2->Text.c_str(), (char *)&psipx->sa_socket, 2); 		// Network order
    }
    else
    {
		AtoH(EPort2->Text.c_str(), (char *)&psipx->sa_socket, 2); 		// Network order
    }
   	return true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnWSAaccept(TMessage &Message)
{
 	int rc, addr_len;
 	SOCKADDR addr;
 	if(WSAGETSELECTERROR(Message.LParam) != 0)
    {
		ShowMessage(" ");
		WSAAsyncSelect((SOCKET)Message.WParam, Handle, 0, 0);
		return;
 	} // if
 	addr_len = sizeof(addr);
    if(m_af == AF_NETBIOS) addr_len = sizeof(SOCKADDR_NB);
 	sock = accept((SOCKET)Message.WParam, (LPSOCKADDR)&addr, (int *)&addr_len);
 	if(sock == INVALID_SOCKET)
    {
		ShowMessage(" ");
		return;
 	} // if
 	rc = WSAAsyncSelect(sock, Handle, WSA_NETEVENT, FD_READ|FD_CLOSE);
 	if (rc > 0)
    {
		ShowMessage(" WSAAsyncSelect");
		return;
 	} // if
	Button1Click(NULL);
 	StatusBar1->Panels->Items[0]->Text = " ";
    StatusBar1->Panels->Items[0]->Text = StatusBar1->Panels->Items[0]->Text + ".    .";
    m_hod = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnWSAnetevent(TMessage &Message)
{
	char coord[2];
	switch(WSAGETSELECTEVENT(Message.LParam))
    {
     	case FD_READ:
        {
            if(!m_first) m_first_recv = true;
			switch(m_type)
            {
            	case SOCK_STREAM:
                case SOCK_SEQPACKET:
                {
					recv((SOCKET)Message.WParam, coord, 2, 0);
                    m_hod = true;
                    set_mas(coord,2);
                    PaintBox1->Invalidate();
                }
                break;
                case SOCK_DGRAM:
                {
                	switch(m_af)
                    {
                     	case AF_INET:
                        {
							SOCKADDR_IN dest_sin;
					    	if(!FillAddrIN(&dest_sin, TRUE))
						    {
    							closesocket(sock);
				        		break;
		    				}
                            int addr_length = sizeof(dest_sin);
                            recvfrom((SOCKET)Message.WParam, coord, 2, 0, (PSOCKADDR)&dest_sin, &addr_length);
        		            m_hod = true;
		                    set_mas(coord,2);
                            PaintBox1->Invalidate();
                    	}
                    	break;
                        case AF_IPX:
                        {
							SOCKADDR_IPX dest_sipx;
                            ZeroMemory(&dest_sipx, sizeof(dest_sipx));
				            dest_sipx.sa_family = AF_IPX;
						    AtoH(EAddr->Text.c_str(), (char *)&dest_sipx.sa_netnum, 4);        	// Network order
						    AtoH(EPort->Text.c_str(), (char *)&dest_sipx.sa_nodenum, 6);  		// Network order
						    AtoH(EPort2->Text.c_str(), (char *)&dest_sipx.sa_socket, 2); 		// Network order
                            int addr_length = sizeof(dest_sipx);
                            recvfrom((SOCKET)Message.WParam, coord, 2, 0, (PSOCKADDR)&dest_sipx, &addr_length);
							m_hod = true;
		                    set_mas(coord,2);
                            PaintBox1->Invalidate();
                        }
                        break;
                    }
                }
                break;
            }
        }
        break;
        case FD_CLOSE:
        {
         	StatusBar1->Panels->Items[0]->Text = " ";
        }
        break;
    }
}
//---------------------------------------------------------------------------
void TForm1::AtoH(char * src, char * dest, int destlen)
{
	while(destlen--)
    {
		*dest++ = (char)((BtoH(*src++) << 4) + BtoH(*src++));
    }
}
//---------------------------------------------------------------------------
unsigned char TForm1::BtoH(char ch)
{
    if (ch >= '0' && ch <= '9') return (unsigned char)(ch - '0');        // Handle numerals
    if (ch >= 'A' && ch <= 'F') return (unsigned char)(ch - 'A' + 0xA);  // Handle capitol hex digits
    if (ch >= 'a' && ch <= 'f') return (unsigned char)(ch - 'a' + 0xA);  // Handle small hex digits
    return(255);
}
//---------------------------------------------------------------------------
void TForm1::HtoA(char * src, char * dest, int srclen)
{
    char * destptr; 									// temp pointers
    UCHAR * srcptr;
    srcptr = (UCHAR *)src;
    destptr = dest;
    while(srclen--)
    {
    	*destptr++ = HtoB((UCHAR)(*srcptr >> 4));      	// Convert high order nibble
    	*destptr++ = HtoB((UCHAR)(*srcptr++ & 0x0F));  	// Convert low order nibble
    }
    *destptr = 0;  										// Null terminator
}
//---------------------------------------------------------------------------
char TForm1::HtoB(UCHAR ch)
{
    if (ch <= 9) return (char)('0' + ch);        	// handle decimal values
    if (ch <= 0xf) return (char)('A' + ch - 10); 	// handle hexidecimal specific values
    return('X');                                 	// Someone screwed up
}
//---------------------------------------------------------------------------
void TForm1::GetAddrString(PSOCKADDR_IPX pSAddr, char * dest)
{
    char abuf[15];                              	// temp buffer
    char * currptr;                             	// temp destination pointer
    currptr = dest; 								// initialize destination pointer
    HtoA((char *)&pSAddr->sa_netnum, abuf, 4);  	// convert network number
    lstrcpy(currptr, abuf);
    currptr += 8;
    lstrcat(currptr, ".");                      	// don't forget seperator
    currptr++;
    HtoA((char *)&pSAddr->sa_nodenum, abuf, 6); 	// convert node number
    lstrcat(currptr, abuf);
    currptr += 12;
    lstrcat(currptr, ".");                      	// seperator
    currptr++;
    HtoA((char *)&pSAddr->sa_socket, abuf, 2);  	// convert socket number
    lstrcat(currptr, abuf);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PaintBox1Paint(TObject *Sender)
{
	int i, j;
    int w = PaintBox1->Width;
    int h = PaintBox1->Height;
    PaintBox1->Canvas->Rectangle(0,0,w,h);
    for(i=0; i<25; i++)
     	for(j=0; j<25; j++)
        {
         	if(m_mas[i][j] == 1) PaintBox1->Canvas->TextOut((double)w/25*((double)i+0.3),(double)h/25*((double)j+0.1),ch1);
         	if(m_mas[i][j] == 2) PaintBox1->Canvas->TextOut((double)w/25*((double)i+0.3),(double)h/25*((double)j+0.1),ch2);
		}
    for(i=1; i<25; i++)
    {
     	PaintBox1->Canvas->MoveTo((double)w/25*i,0);
        PaintBox1->Canvas->LineTo((double)w/25*i,h);
        PaintBox1->Canvas->MoveTo(0,(double)h/25*i);
        PaintBox1->Canvas->LineTo(w,(double)h/25*i);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PaintBox1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if(Button == mbLeft)
    {
	    int w = PaintBox1->Width;
    	int h = PaintBox1->Height;
		char coord[2];
    	coord[0] = (char)floor((double)X/((double)w/25));
        coord[1] = (char)floor((double)Y/((double)h/25));
        if((m_mas[coord[0]][coord[1]] == 0)&&(m_Send(coord)))
        {
        	m_hod = false;
    	    PaintBox1->Canvas->TextOut((double)w/25*((double)coord[0]+0.3),(double)h/25*((double)coord[1]+0.1),ch1);
	        set_mas(coord,1);
        }
    }
}
//---------------------------------------------------------------------------
void TForm1::set_mas(char coord[2], int val)
{
    if(m_first)
    {
        ch1 = 'X';
        ch2 = '0';
    }
    else
    {
        ch1 = '0';
        ch2 = 'X';
    }
	if(coord[0] > 24) coord[0] = 24;
    if(coord[1] > 24) coord[1] = 24;
	if((val >= 0)&&(val <= 2)) m_mas[coord[0]][coord[1]] = val;
    else m_mas[coord[0]][coord[1]] = 0;
    if(m_hod) StatusBar1->Panels->Items[0]->Text = " .";
    else StatusBar1->Panels->Items[0]->Text = "   .";
    if(IsWinner(1))
    {
    	ShowMessage(" !");
        Button1Click(NULL);
    }
    if(IsWinner(2))
    {
	    ShowMessage(" !");
        Button1Click(NULL);
    }
}
//---------------------------------------------------------------------------
bool TForm1::IsWinner(int val)
{
	int m, i, j;
    int cnt;
	for(i=0; i<25; i++)
    	for(j=0; j<25; j++)
        {
         	if(m_mas[i][j] == val)
            {
            	cnt = 0;
            	for(m=1; m<5; m++)
                 	if(get_mas(i+m,j) == val) cnt++;
                if(cnt >= 4) return true;
            	cnt = 0;
            	for(m=1; m<5; m++)
                 	if(get_mas(i,j+m) == val) cnt++;
                if(cnt >= 4) return true;
            	cnt = 0;
            	for(m=1; m<5; m++)
                 	if(get_mas(i+m,j+m) == val) cnt++;
                if(cnt >= 4) return true;
            	cnt = 0;
            	for(m=1; m<5; m++)
                 	if(get_mas(i-m,j+m) == val) cnt++;
                if(cnt >= 4) return true;
            }
        }
	return false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	ZeroMemory(m_mas,sizeof(m_mas));
    PaintBox1->Invalidate();
}
//---------------------------------------------------------------------------
int TForm1::get_mas(int i, int j)
{
	if((i>=0)&&(i<25)&&(j>=0)&&(j<25)) return m_mas[i][j];
    else return 255;
}
//---------------------------------------------------------------------------

